<template>
    <div :class="blockClass">
        <div class="padding" v-if="block">
            <h3>СНИЛС или ИНН <img
                    src="static/img/head/content/tooltip.png"
                    v-tooltip.right-start="tooltip"
            ></h3>
        </div>
        <hr v-if="block"/>
        <div class="padding" v-if="!block">

                    <label>СНИЛС или ИНН <img
                            src="static/img/head/content/tooltip.png"
                            v-tooltip.right-start="tooltip"
                    ></label>
            <div class="row">
                <div class="columns eight">
                    <div class="input-field" style="position: relative;">
                        <span class="placeholder" v-show="isInnC || isSnilsC">{{label}}</span>
                        <input type="tel"
                               name="СНИЛС или ИНН"
                               id="inn"
                               v-model="value"
                               v-mask="mask"
                               v-validate="validate"
                               :class="validateClass"
                               ref="snilsOrInn"
                               @input="input"
                               autocomplete="off"
                               data-code="snilsInvalidFormat, snilsTooShort, snilsTooLong, snilsCodeIncorrect, snilsOrInnCodeIncorrect"
                        >
                        <validate-message v-show="vErrors.has('СНИЛС или ИНН')">
                          {{ vErrors.first('СНИЛС или ИНН') }}
                        </validate-message>
                    </div>
                </div>
            </div>
        </div>
        <div v-else>
            <div class="padding">
                <div class="row">
                    <div class="columns four"></div>
                </div>
                <div class="row">
                    <div class="columns eight">
                        <div class="input-field">
                            <span class="placeholder" v-show="isInnC || isSnilsC">{{label}}</span>
                            <input type="tel"
                                   name="СНИЛС или ИНН"
                                   id="inn"
                                   v-model="value"
                                   v-mask="mask"
                                   v-validate="validate"
                                   :class="validateClass"
                                   ref="snilsOrInn"
                                   @input="input"
                                   autocomplete="off"
                                   data-code="snilsInvalidFormat, snilsTooShort, snilsTooLong, snilsCodeIncorrect, snilsOrInnCodeIncorrect"
                            >
                            <validate-message v-show="vErrors.has('СНИЛС или ИНН')">
                              {{ vErrors.first('СНИЛС или ИНН') }}
                            </validate-message>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    /* eslint-disable */
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import UserGetter from '@/mixins/User/UserGetterMixin'
    import backendApi from '@/utils/backend-api'
    import dayjs from 'dayjs'
    import debounce from 'lodash/debounce'

    export default {
      name: 'snils-or-inn',
      mixins: [GetValidateClass, UserGetter],
      props: {
        profile: {
          type: Boolean,
          default: false
        },
        block: {
          type: Boolean,
          default: true
        },
        auto: {
          type: Boolean,
          default: false,
        }
      },
      data() {
        return {
          value: '',
          cValue: '',
          autoINN: {
            trigger: 'click hover',
            autoHide: true,
            content: '<p>Ваш ИНН получен автоматически</p>',
            targetClasses: 'registration-tooltip-icon',
            delay: {show: 500, hide: 500},
            classes: 'registration-tooltip adaptive-tooltip'
          },
          tooltip:{
            trigger: 'click hover',
            autoHide: true,
            content:` <p >
                        Страховой номер индивидуального лицевого счёта. Получить СНИЛС можно при устройстве на работу или самостоятельно в Пенсионном фонде России или МФЦ по месту регистрации (в том числе временной) или фактического проживания.
                    </p>
                    <p >
                        Идентификационный номер налогоплательщика - узнать ИНН можно на сайте Федеральной Налоговой Службы
                    </p>
                    <p><a v-close-popover='false' class='tooltip-close'>Закрыть</a></p>`,
            targetClasses: 'registration-tooltip-icon',
            delay: {show: 500, hide: 500},
            classes: 'registration-tooltip adaptive-tooltip'
          }
        }
      },
      watch: {
        mask () {
          // console.log('value', this.value)
          this.value = this.value.replace(/[^\d]/g, '')
        },
        value () {
          // console.log('update profile snilsOrInn', this.value)
          this.computedValue = this.value
            if (this.profile) {
            // console.log('update profile snilsOrInn', this.value)
              this.$user.snilsOrInn = this.value.replace(/[^\d]/g, '')
            } else {
              this.$user.snilsOrInn = this.value;
            }
        },
        cValue () {
          // console.log('cValue', this.cValue)
        }
      },
      computed: {
        validate () {
          if (this.isSnils) {
            return 'required'
          } else if (this.isInn) {
            return 'required'
          } else {
            return 'required'
          }
        },
        computedValue: {
          get: function () {
            // console.log(this)
            return this.cValue
          },
          set: debounce(function(val) {
            this.cValue = val
          }, 1200)
        },
        isSnils() {
          // console.log('computed value', this.computedValue)
          return this.value.replace(/[^\d]/g, '').length === 11
        },
        isInn() {
          return this.value.replace(/[^\d]/g, '').length === 12
        },
        isInnC () {
          return this.computedValue.replace(/[^\d]/g, '').length === 12
        },
        isSnilsC () {
            return this.computedValue.replace(/[^\d]/g, '').length === 11
        },
        mask() {
          if (this.isSnils) {
            return "### ### ### ##"
          } else {
            return "#### #### ####"
          }
        },
        label () {
          if (this.isSnilsC) {
            return 'СНИЛС'
          } else if(this.isInnC) {
            return 'ИНН'
          } else {
            return 'СНИЛС или ИНН'
          }
        },
        validateClass () {
          const error =  this.getValidateClass('СНИЛС или ИНН')
          const classList = {}
          if(error) {
            classList.error = true
          }
          if(!this.block) {
            classList['no-margin-bottom'] = true
          }

          if (this.isInnC || this.isSnilsC) {
            classList.placeholder = true
          }

          return classList
        },
        firstName () {
          return this.$user.firstName;
        },
        middleName () {
          return this.$user.middleName;
        },
        lastName () {
          return this.$user.lastName;
        },
        birthDate () {
          return dayjs(this.$user.bDay).format('YYYY-MM-DDT00:00:00.000Z');
        },
        passport () {
          return this.$user.passport;
        },
        passportSerial () {
          try {
            return this.passport.split(' ')[0]
          } catch (e) {}
        },
        passportNumber () {
          try {
            return this.passport.split(' ')[1]
          } catch (e) {}
        },
        blockClass () {
          const object = {}
          if (this.block) {
            object['white-block'] = true
          }
          return object
        }
      },
      async created () {
        this.value = this.$auth.isAuth ? this.$user.snilsOrInn : await this.getUserInn()
        if (typeof this.value !== "string") {
          this.value = ''
        }
        // console.log('snilsOrInn is profile', this.profile)
        // console.log('snilsOrInn is profile', this.value)
      },
      methods: {
        input (e) {
          this.$validator.errors.clear()
        },
        getUserInn () {
            return backendApi.postData('tkb/inn', {
              F: this.lastName,
              I: this.firstName,
              O: this.middleName,
              BD: this.birthDate,
              PS: this.passportSerial,
              PN: this.passportNumber
            }, 'https://new.webbankir.com/api/').then((response) => {
              return Promise.resolve(response.data.inn || '' )
            }).catch((e) => {
              console.warn('Can"t get inn', e)
              return Promise.resolve('') // значение в любом случае должно быть строкой, поэтому возвращаем так.
            })
        }
      }
    }
</script>

<style scoped lang="scss">
  h3 {
    text-transform: none !important;
  }

  /*.no-margin-bottom {*/
  /*margin-bottom: 0;*/
  /*}*/

  div.input-field {
    position: relative;
    span.placeholder {
      position: absolute;
      width: 100px;
      line-height: 38px;
      background-color: #f8f8f8;
      border: 1px solid #e9eff4;
      padding: 0 20px;
      box-sizing: border-box;
      border-bottom-left-radius: 5px;
      border-top-left-radius: 5px;
      border-top: none;
      border-bottom: none;
      transition-duration: 0.3s;
      height: 38px;
      margin: 1px 0;
      margin-left: 1px;
    }
    input.placeholder {
      padding-left: 110px;
    }
  }
</style>
